#!/bin/sh
# The following was generated from 
# NLS/en/failover.gen
#
MF_FAILOVER=failover.cat
#
MS_FAILOVER_BE=1
PRIMARY_LABEL=1
PRIMARY_HELP=2
SCREEN_TITLE=3
#!/bin/sh
#ident "@(#)failover.BE	1.2"
#
#    Back end script for netconfig prompter.
#
#
# Internationalisation
#
_primary_label="`dspmsg $MF_FAILOVER -s $MS_FAILOVER_BE $PRIMARY_LABEL \"Primary interface\"`"
_primary_help="`dspmsg $MF_FAILOVER -s $MS_FAILOVER_BE $PRIMARY_HELP \"Select interface to back up\"`"
_screen_title="`dspmsg $MF_FAILOVER -s $MS_FAILOVER_BE $SCREEN_TITLE \"Backup Device Configuration\"`"

exec 3>&2
exec 2>/dev/null

INTERFACE_NAME=$1
INTERFACE_NUMBER=$2

if [ ! "$NCFGBIN" ]
then
    NCFGBIN=/usr/lib/netcfg/bin
fi

while read line
do
    set - $line
    REQUEST=$1
    shift
    ARGS=$*
    case $REQUEST in

        LIST)
            set - $ARGS
            case $1 in

                BASIC)
		    echo "\
			{ PRIMARY \"$_primary_label\" LIST \"$_primary_help\" } \
		    "
                    ;;
                *)
                    echo "BE: Unknown argument to LIST" >&3
                    exit 1
                    ;;
            esac
            ;;

        CURRENT)
            set - $ARGS
            case $1 in

                BASIC)
		    echo "\
			{ PRIMARY 1 \"$PRIMARY\" } \
		    "
		    ;;
                *)
                    echo "BE: Unknown argument to CURRENT" >&3
                    exit 1
                    ;;
            esac
            ;;

        VALUES)
            set - $ARGS
            case $1 in
                PRIMARY)
		    #
		    # List all the interfaces here except ones that already
		    # have a backup device and the current interface being
		    # being configured. We should also tag on the netX part.
		    #
		    list=""
		    cd /usr/lib/netcfg/info
		    for net in net*
		    do
			if [ "$net" != "${INTERFACE_NAME}${INTERFACE_NUMBER}" ]
			then
			    is_primary=`/usr/lib/netcfg/query/$net is_primary`
			    sibling_interface=`/usr/lib/netcfg/$net sibling_interface`
			    if [ "$is_primary" = "Y" -a "$sibling_interface" = "" ]
			    then
				    desc=`cat $net | grep "^DESCRIPTION" | sed 's/^DESCRIPTION="\(.*\)"$/\1/'`
				    if [ "$list" = "" ]
				    then
					list="{$net - $desc}"
				    else
					list="$list {$net - $desc}"
				    fi
			    fi
			fi
		    done
                    echo "$list"
                    ;;
		*)
		    echo "BE: Unknown argument to VALUES" >&3
		    exit 1
		    ;;
            esac
            ;;

        SET)
            set - $ARGS
            case $1 in
                PRIMARY)
		    #
		    # Need to be careful. We don't just want to take the
		    # descriptive name as there may be more than one
		    # interface that uses that card, we should also tag
		    # on the end the netX part.
		    #
		    shift
                    PRIMARY="$*"
	            echo "OK"
                    ;;
                *)
                    echo "BE: Unknown argument to SET" >&3
                    exit 1
                    ;;
            esac
            ;;
	PAGEINIT)
	    case $1 in
		BASIC)
		    echo "{$_screen_title} {} {HW_network} {ncfgD.failover.html} {OK}"
		    ;;
	        *)
		    echo "BE: Unknown argument to PAGEINIT" >&3
		    exit 1
		    ;;
	    esac
	    ;;
        USER_DONE)
	    echo "OK"
            ;;
        *)
            echo "BE: Unknown request <$line>" >&3
            exit 1
            ;;
    esac
done
